<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Nursery extends CI_Model{

    function __construct()
    {
            $this->load->database();
    }

    public function get_school_type() {
        $result = $this->db->select('id, name')->get('school_type')->result_array();

        $school_type = array();
        foreach($result as $r) {
            $school_type[$r['id']] = $r['name'];
        }
        $school_type[''] = 'Select School Type';
        return $school_type;
    }
    
    public function get_users() {
        $result = $this->db->select('id, first_name, last_name')->where('status','Active')->get('users')->result_array();

        $user = array();
        foreach($result as $r) {
            $user[$r['id']] = $r['first_name'].' '.$r['last_name'];
        }
        $user[''] = 'Select User';
        return $user;
    }
    public function get_usersindex() {
//        $result = $this->db->select('id, first_name, last_name')->get('users')->result_array();
        $result = $this->db->query("SELECT users.id,users.first_name,users.last_name FROM `users`,`nursery_master` as `mntr` WHERE `mntr`.`user_id` = `users`.`id`")->result_array();

        $user = array();
        foreach($result as $r) {
            $user[$r['id']] = $r['first_name'].' '.$r['last_name'];
        }
//        $user[''] = 'Select User';
        return $user;
    }

    public function get_facility() {
        $result = $this->db->select('*')->get('facility')->result_array();
        return $result;
    }

    public function get_multiple_image($id) {
        $this->db->select('*');
        $this->db->from('nursery_other_image');
        $result = $this->db->where('nursery_master_id',$id)->get()->result_array();

        return $result;
    }

    /*
     * Get posts
     */
    function getRows($id = ""){
        if(!empty($id)){
            $query = $this->db->get_where('nursery', array('id' => $id));
            return $query->row_array();
        }else{
            $query = $this->db->get('nursery');
            return $query->result_array();
        }
    }
    function getRows_new($id = ""){
        if(!empty($id)){
//            $query = $this->db->get_where('nursery', array('id' => $id));
//            $this->db->select("nm.*,st.name as school_type,GROUP_CONCAT(`f`.`name` SEPARATOR ',') as `facility_name`");
//            $this->db->from('nursery_master as nm');
//            $this->db->join('school_type as st', 'nm.school_type_id = st.id', 'LEFT');
//            $this->db->join('facility as f', 'nm.facility_id = f.id', 'LEFT');
//            $this->db->where('FIND_IN_SET(`f`.`id`, `nm`.`facility_id`) != 0');
//            $this->db->group_by('nm.id');
            $query = $this->db->query("SELECT `nm`.*,`st`.name as school_type, GROUP_CONCAT(`f`.`name` SEPARATOR ', ') as `facility_name` FROM `nursery_master` as `nm`,`facility` as `f`,`school_type` as `st` WHERE FIND_IN_SET(`f`.`id`, `nm`.`facility_id`) !=0 AND `nm`.`id` = $id AND `nm`.`school_type_id`= `st`.`id` GROUP BY `nm`.`id`");
//            $query = $this->db->get_where('nursery_master',array('nm.id' => $id));
//             echo $query; die;
//            $query = $this->db->get();
            return $query->row_array();
        }else{
            $query = $this->db->get('nursery_master');
            return $query->result_array();
        }
    }

    /*
     * Insert post
     */
    public function insert($data = array()) {
//        print_r($data); die;
//        $data['date'] = date('Y-m-d',strtotime($data['date']));
//        echo 'aad'; print_r($data); die;
        $insert = $this->db->insert('nursery_master', $data);
        if($insert){
            return $this->db->insert_id();
        }else{
            return false;
        }
    }
    public function insert_otherimage($data = array()) {
//        print_r($data); die;
//        $data['date'] = date('Y-m-d',strtotime($data['date']));
//         print_r($data); die;
//         echo 'aa'; die;
//echo $id; die;
        $insert = $this->db->insert_batch('nursery_other_image', $data);
        if($insert){
            return $this->db->insert_id();
        }else{
            return false;
        }
    }

    /*
     * Update post
     */
    public function update($data, $id) {
        if(!empty($data) && !empty($id)){
            $update = $this->db->update('nursery_master', $data, array('id'=>$id));
            return $update?true:false;
        }else{
            return false;
        }
    }

    /*
     * Delete post
     */
    public function delete($id){
        $delete = $this->db->delete('nursery_master',array('id'=>$id));
        return $delete?true:false;
    }
    /*
     * Delete post
     */
    public function deleteImagePath($id){
        $this->db->select('other_image');
        $this->db->from('nursery_other_image');
        $imageName= $this->db->where('id',$id)->get()->row_array();
        
        $removePath = './uploads/other_images/'.$imageName['other_image'];
        unlink($removePath);
        $delete = $this->db->delete('nursery_other_image',array('id'=>$id));
        return $delete?true:false;
    }

    /*
     * Status Change
     */
    public function statusChange($id) {
        if(!empty($id)){
            $this->db->select('status');
            $this->db->from('nursery_master');
            $result= $this->db->where('id',$id)->get()->row_array();
            if($result['status']=="Active"){
                $data['status']='Inactive';
            } else {
                $data['status']='Active';
            }
            $update = $this->db->update('nursery_master', $data, array('id'=>$id));
            return $update?true:false;
        }else{
            return false;
        }
    }

    function getotherImage($id){
        if(!empty($id)){
            $query = $this->db->get_where('nursery_other_image', array('nursery_master_id' => $id));
            return $query->result_array();
        }
    }
}