<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Category extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->helper('form');
        $this->load->library('form_validation');
        $this->load->model('admin/categories');
        $this->load->library('session');
        $this->load->library('upload');
        
    }

    public function index(){
        $data = array();

        //get messages from the session
       
        $data['categoryList'] = $this->categories->get_category();
        $this->db->select("*");
        $this->db->from('category')->order_by("id", "desc");
        $data['category'] = $this->db->get()->result_array();
        //print_r($data); die;
        $this->load->view('admin/include/header', $data);
        $this->load->view('admin/category/index', $data);
        $this->load->view('admin/include/footer');
    }

   

    public function addcategory() {
        $data=array();
       

        $this->load->view('admin/include/header', $data);
        $this->load->view('admin/category/add-edit', $data);
        $this->load->view('admin/include/footer', $data);
    }
    public function updatecategory($id) {
        $data=array();
       $this->db->select("*");
      $this->db->from('category');
       $this->db->where('id',$id);
      $data['category'] = $this->db->get()->row_array();
        
        $this->load->view('admin/include/header', $data);
        $this->load->view('admin/category/add-edit', $data);
       $this->load->view('admin/include/footer', $data);
    }

    /*
     * Add post content
     */
    public function add(){
        $data = array();
        $postData = array();

            //prepare post data
            $postData = array(
                'name' => $this->input->post('name'),
                'link' => $this->input->post('link'),
                'description' => $this->input->post('description'),
                );
                //for image upload
                $config['upload_path'] = "./uploads/category_logo/";
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $file_name = trim(addslashes($_FILES["image"]['name']));
                $file_name = str_replace(' ', '_', $file_name);
                $this->upload->initialize($config);
                if(!empty($_FILES["image"]['name'])){
                    if (!$this->upload->do_upload('image',FALSE)) {
                        echo '2';
                        $error = array('error' => $this->upload->display_errors());
                        $this->load->view('admin/managecategory/add-edit', $error);
                    } else {
                        $upload_data = $this->upload->data();
                    }
                }
                $postData['image']= isset($_FILES["image"]['name'])?$file_name:'';
                
                //insert post datat
                $insert = $this->categories->insert($postData);
                if($insert){
                   $this->session->set_flashdata('success' , 'Data  Successfully Added');
                redirect(base_url() . 'admin/Category', 'refresh');
                }else{
                   $this->session->set_flashdata('success' , 'Data  Successfully Added');
                redirect(base_url() . 'admin/Category', 'refresh');
                }
      }
    /*
     * Update post content
     */
    public function edit($id){
        $data = array();
            $this->form_validation->set_rules('name', 'Category Name', 'required');
           
            //prepare post data
             $postData = array(
                'name' => $this->input->post('name'),
                'link' => $this->input->post('link'),
                'description' => $this->input->post('description'),
                );
           
            //validate submitted form data
            if($this->form_validation->run() == true) {
                if(isset($_FILES['image']['name']) && (!empty($_FILES['image']['name']))) {
            //for image upload

                $config['upload_path'] = "./uploads/category_logo/";
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $file_name = trim(addslashes($_FILES["image"]['name']));
                $file_name = str_replace(' ', '_', $file_name);
                $this->upload->initialize($config);
                if (!$this->upload->do_upload('image')) {
                    echo '2';
                    $error = array('error' => $this->upload->display_errors());
                    $this->load->view('admin/category/add-edit', $error);
                } else {
                    $upload_data = $this->upload->data();
                }
                $postData['image']= isset($_FILES["image"]['name'])?$file_name:'';
                }
                //update post data
                $update = $this->categories->update($postData, $id);

                if($update){
                    $this->session->set_flashdata('success' , 'Data  Successfully Updated');
                redirect(base_url() . 'admin/Category', 'refresh');
                } else {
                     $this->session->set_flashdata('success' , 'Data  Successfully Updated');
                redirect(base_url() . 'admin/Category', 'refresh');
                }
            }
   }

    /*
     * Delete post data
     */
    public function delete(){
        //check whether post id is not empty
        $id = $this->input->post('id');
        if($id){
            //delete post
            $delete = $this->categories->delete($id);

            if($delete){
                $this->session->set_flashdata('success' , 'Data  Successfully Deleted');
                redirect(base_url() . 'admin/Category', 'refresh');
            }else{
                $this->session->set_flashdata('success' , 'Data  Successfully Deleted');
                redirect(base_url() . 'admin/Category', 'refresh');
            }
        }
    }

    public function statuschange($id) {

        //check whether post id is not empty
        if($id){
            $status = $this->categories->statusChange($id);

            if($status){
                echo '1';
            } else {
                echo '0';
            }
        }
    }
}