<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Users extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->helper('form');
        $this->load->library('form_validation');
        $this->load->model('admin/user');
        $this->load->model('admin/profiles');
        $this->load->library('session');
        $this->load->library('upload');
//        if(!$this->session->userdata('email')){
//             redirect('/admin');
//        }
        $admin_session_data = $this->session->userdata('backend');
        $this->session_id = $admin_session_data['id'];
        if(!$admin_session_data['role']=='admin'){
             redirect('/admin/login');
        }
    }

    public function index(){
        $data = array();

        //get messages from the session
        if($this->session->userdata('success_msg')){
            $data['success_msg'] = $this->session->userdata('success_msg');
            $this->session->unset_userdata('success_msg');
        }
        if($this->session->userdata('error_msg')){
            $data['error_msg'] = $this->session->userdata('error_msg');
            $this->session->unset_userdata('error_msg');
        }

//        $data['users'] = $this->user->getRows();
//        $data['title'] = 'Event';

        //load the list page view
//        $session_id = $this->session_id;
        $data['profile'] = $this->profiles->getProfile($this->session_id);
        $this->load->view('admin/include/header', $data);
        $this->load->view('admin/include/commonheader',$data);
        $this->load->view('admin/users/index', $data);
        $this->load->view('admin/include/footer');
    }

    public function get_items()
    {
      $draw = intval($this->input->get("draw"));
      $start = intval($this->input->get("start"));
      $length = intval($this->input->get("length"));
      
      $this->db->select("*");
      $this->db->from('users');
      $this->db->where('status','Active');
      $this->db->order_by('created_on','DESC');
      $query = $this->db->get();

      $data = array();

      $i=1;
      foreach($query->result() as $r) {
        $data[] = array(
                  "id"=>$i,
                  "profilepic"=>$r->profilepic == true ? '<img src="'.base_url()."uploads/profile_image/".$r->profilepic.'" class="avatar">' : '<img src="'.base_url()."assets/images/default-avatar.jpg".'" class="avatar">',
                  "first_name"=>$r->first_name,
                  "email"=>$r->email,
                  "phone"=>$r->phone,
                  "created_on"=>date('jS M, Y', strtotime($r->created_on)),
                  "action"=>'<a href="'.base_url().'admin/users/view/'.$r->id.'"><button type="button" class="btn btn-icon btn-sm" title="View"><i class="fa fa-eye"></i></button></a>
                   <a href="'.base_url().'admin/users/updateuser/'.$r->id.'" style="display:none;"><button type="button" class="btn btn-icon btn-sm" title="Edit"><i class="fa fa-edit"></i></button></a>
                   <a href="#" id="'.$r->id.'" class="remove" ><button type="button" class="btn btn-icon btn-sm" title="Delete"><i class="fa fa-trash-o text-danger"></i></button></a>'
               );
        $i++;
      }
      $result = array(
               "draw" => $draw,
                 "recordsTotal" => $query->num_rows(),
                 "recordsFiltered" => $query->num_rows(),
                 "data" => $data
            );
      echo json_encode($result);
      exit();
   }

    /*
     * Post details
     */
    public function view($id){
        $data = array();

        //check whether post id is not empty
        if(!empty($id)){
            $data['user'] = $this->user->getRows($id);

            //load the details page view
            $data['profile'] = $this->profiles->getProfile($this->session_id);
            $this->load->view('admin/include/header', $data);
            $this->load->view('admin/include/commonheader',$data);
            $this->load->view('admin/users/view', $data);
            $this->load->view('admin/include/footer');
        }else{
            redirect('/admin/users');
        }
    }

    public function adduser(){
        $data=array();
        $data['title'] = 'Create User';
        $data['action'] = 'Add';
        $data['school_names'] = $this->user->get_school_name($this->session_id);
        //load the add page view
        $data['profile'] = $this->profiles->getProfile($this->session_id);
        $this->load->view('admin/include/header', $data);
        $this->load->view('admin/include/commonheader',$data);
        $this->load->view('admin/users/add-edit', $data);
//        $this->load->view('include/footer', $data);
    }
    public function updateuser($id){
        $data=array();
        $data['school_names'] = $this->user->get_school_name($this->session_id);
//        $postData=array();
        $postData = $this->user->getRows($id);
        $data['user'] = $postData;
        $data['title'] = 'Update User';
        $data['action'] = 'Edit';

        //load the edit page view
        $data['profile'] = $this->profiles->getProfile($this->session_id);
        $this->load->view('admin/include/header', $data);
        $this->load->view('admin/include/commonheader',$data);
        $this->load->view('admin/users/add-edit', $data);
//        $this->load->view('include/footer', $data);
    }

    /*
     * Add post content
     */
    public function add(){
        $data = array();
        $postData = array();
            //prepare post data
            $postData = array(
                'first_name' => $this->input->post('first_name'),
                'last_name' => $this->input->post('last_name'),
                'email' => $this->input->post('email'),
                'phone' => $this->input->post('phone'),
                'password' => md5($this->input->post('password'))
            );
                //for image upload
                //for image upload
                $config['upload_path'] = "./uploads/profile_image/";
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $file_name = trim(addslashes($_FILES["profilepic"]['name']));
                $file_name = str_replace(' ', '_', $file_name);
                $this->upload->initialize($config);
                if (!$this->upload->do_upload('profilepic')) {
                    echo '2'; exit();
                } else {
                    $upload_data = $this->upload->data();
                }
                $postData['profilepic']= isset($_FILES["profilepic"]['name'])?$file_name:'';
                
                //insert post datat
                $insert = $this->user->insert($postData);
                if($insert){
                    echo '1';
//                    $this->session->set_userdata('success_msg', 'Event has been added successfully.');
//                    redirect('/users');
                }else{
                    echo '0';
//                    $data['error_msg'] = 'Some problems occurred, please try again.';
                }
            }


    /*
     * Update post content
     */
    public function edit($id){
        $data = array();
            $postData = array();
            //prepare post data
            $postData = array(
                'first_name' => $this->input->post('first_name'),
                'last_name' => $this->input->post('last_name'),
                'email' => $this->input->post('email'),
                'phone' => $this->input->post('phone')
//                'password' => $this->input->post('password')
            );
                //for image upload
            if(isset($_FILES['profilepic']['name']) && (!empty($_FILES['profilepic']['name']))) {
                //for image upload
                $config['upload_path'] = "./uploads/profile_image/";
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $file_name = trim(addslashes($_FILES["profilepic"]['name']));
                $file_name = str_replace(' ', '_', $file_name);
                $this->upload->initialize($config);
                if (!$this->upload->do_upload('profilepic')) {
                    echo '2'; exit();
                } else {
                    $upload_data = $this->upload->data();
                }
                $postData['profilepic']= isset($_FILES["profilepic"]['name'])?$file_name:'';
            }
//            print_r($postData); die;
            $update = $this->user->update($postData, $id);
              if($update){
                echo '1'; exit();
            }else{
                echo '0'; exit();
            }
      }

    /*
     * Delete post data
     */
    public function delete($id){
        //check whether post id is not empty
        if($id){
            //delete post
            $delete = $this->user->delete($id);

            if($delete){
                echo '1';
//                $this->session->set_userdata('success_msg', 'Event has been removed successfully.');
            }else{
                echo '0';
//                $this->session->set_userdata('error_msg', 'Some problems occurred, please try again.');
            }
        }
//        redirect('/users');
    }
}